package com.adaptionsoft.games.uglytrivia

import com.adaptionsoft.games.uglytrivia.core.GameBoard
import com.adaptionsoft.games.uglytrivia.core.Player
import com.adaptionsoft.games.uglytrivia.core.Roll
import com.adaptionsoft.games.uglytrivia.infrastructure.AutogeneratedQuestions
import com.adaptionsoft.games.uglytrivia.infrastructure.InMemoryPlayerPositions
import org.amshove.kluent.shouldEqual
import org.junit.jupiter.api.Test

class GameBoardShould {
    @Test
    fun `move the player on the board`() {
        val player = Player("name")
        val roll = Roll(3)
        val gameBoard = gameBoard()
        gameBoard.addOnStartingPlace(player)

        gameBoard.move(player, roll)

        val place = gameBoard.positionOf(player)
        place shouldEqual 3
    }

    @Test
    fun `fetch a question from the category on which the player is`() {
        val player = Player("name")
        val gameBoard = gameBoard()
        gameBoard.addOnStartingPlace(player)

        gameBoard.move(player, Roll(1))
        val question = gameBoard.fetchQuestionFor(player)

        question.question shouldEqual "Science Question 0"
    }

    private fun gameBoard() = GameBoard(
        AutogeneratedQuestions(),
        InMemoryPlayerPositions()
    )
}